//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

//
//
//
//
//

extern int    macdTimeframe = 0;
extern int    Price         = 0;
extern int    FastPeriod    = 12;
extern int    SlowPeriod    = 26;
extern int    SignalPeriod  = 9;
extern int    MacdMethod    = 2;
extern int    Close.bar     = 0;

extern string  macdmethods  = "";
extern string  __0          = "SMA";
extern string  __1          = "EMA";
extern string  __2          = "Double smoothed EMA";
extern string  __3          = "Double EMA (DEMA)";
extern string  __4          = "Triple EMA (TEMA)";
extern string  __5          = "Leader EMA";
extern string  __6          = "Smoothed MA";
extern string  __7          = "Linear weighted MA";
extern string  __8          = "Parabolic weighted MA";
extern string  __9          = "Alexander MA";
extern string  __10         = "Volume weghted MA";
extern string  __11         = "Hull MA";
extern string  __12         = "Triangular MA";
extern string  __13         = "Sine weighted MA";
extern string  __14         = "Linear regression";
extern string  __15         = "IE/2";
extern string  __16         = "NonLag MA";
extern string  __17         = "Zero lag EMA";

//
//
//
//
//

int init() 
{            
return(0);
}

//
//
//
//
//

int deinit() 
{ 
return(0); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
  
   double clmacdnow = iCustom(NULL,macdTimeframe,"averages_MACD",Price,FastPeriod,SlowPeriod,SignalPeriod,MacdMethod,true,4,Close.bar);
   double clmacdpre = iCustom(NULL,macdTimeframe,"averages_MACD",Price,FastPeriod,SlowPeriod,SignalPeriod,MacdMethod,true,4,Close.bar+1);
   
   //
   //
   //
   //
   //
   
      for (int i=OrdersTotal()-1; i>=0; i--)
      {
          if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
          if (OrderSymbol() !=Symbol())                  continue;
          if (clmacdnow < 0 && clmacdpre >= 0 && OrderType() == OP_BUY)  closeAll(OP_BUY); 
          if (clmacdnow > 0 && clmacdpre <= 0 && OrderType() == OP_SELL) closeAll(OP_SELL);  
             
       } 
return(0);      
} 

//
//
//
//
//

void closeAll(int type)
{
   for (int i=OrdersTotal()-1; i>=0; i--)
   {
      if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) break;
      if (OrderSymbol() !=Symbol())                  continue;
      if (OrderType()==type)
      {
         for (int retries =0; retries<3; retries++)
         {
            RefreshRates();
               if (type == OP_BUY)
                     double closePrice = Bid;
               else         closePrice = Ask;
               if (OrderClose(OrderTicket(),OrderLots(),closePrice,0,Red)) break;
         }               
      }
   }
}


